unit helptools;

interface
uses
  SysUtils;

function StrLeft( SourceStr : PChar; CharNum   : Word): PChar;

function StrRight( SourceStr : PChar; CharNum   : Word): PChar;

function StrSubStr( SourceStr : PChar; StartPos  : Word; CharNum : Word): PChar;

function SubStr( SourceStr : String; StartPos  : Byte; CharNum : Byte): String;

function ParseString(var a : string; breakchar : Char = ' ') : string;


implementation

function StrLeft( SourceStr : PChar;
                  CharNum   : Word): PChar;
var
   EndNewStr : PChar;
begin
     if ((CharNum < StrLen (SourceStr)) and (SourceStr <> nil)) then
     begin
          EndNewStr  := SourceStr;
          Inc(EndNewStr,CharNum);
          EndNewStr^ := #0;
     end;
     Result := SourceStr;
end;

function StrRight( SourceStr : PChar;
                   CharNum   : Word): PChar;
var
   newStrBegin : PChar;
begin
     NewStrBegin := SourceStr;
     if CharNum < StrLen(SourceStr) then
     begin
          Inc(newStrBegin,StrLen(SourceStr)-CharNum);
     end;
     Result := newStrBegin;
end;

function StrSubStr( SourceStr : PChar;
                    StartPos  : Word;
                    CharNum   : Word): PChar;
var
   newStrBegin : PChar;
begin
     if StrLen(SourceStr) >= StartPos then
     begin
          NewStrBegin := StrRight(SourceStr,StrLen(SourceStr)-StartPos+1);
          Result      := StrLeft(NewStrBegin,CharNum);
     end
     else
     begin
          NewStrBegin  := SourceStr;
          NewStrBegin^ := #0;
          Result       := NewStrBegin;
     end;
end;

function SubStr( SourceStr : String;
                 StartPos  : Byte;
                 CharNum   : Byte): String;
var
   aPChar   : PChar;
   newPChar : PChar;
begin
      aPChar := StrAlloc(Length(SourceStr)+1);
      StrPCopy(aPChar,SourceStr);
      newPChar := StrSubStr(aPChar,StartPos,CharNum);
      Result   := StrPas(newPChar);
      StrDispose(aPChar);
end;


function ParseString(var a : string; breakchar : Char = ' ') : string;
var len,i : integer;
var b : string;
begin
  b := '';
  len := Length(a);
  for i:=0 to len-1 do
    if a[i] = breakchar then break;
//  i := AnsiStrScan(PChar(a), Char(breakchar));
  if (i <> 0) and (i <> len) then
  begin
    b := SubStr(a,0,i-1); //StrLeft(PChar(a),i-1);
    a := SubStr(a,i+1,len-1); //StrRight(PChar(a),i);
  end;
  Result := b;
end;

end.
